; *******************************************************************
; *                                                                 *
; *                          logotrap.asm                           *
; *                                                                 *
; *   This is a hackmaster hack which flashes a logo on the screen  *
; *   every time the pilot is powered up.                           *
; *                                                                 *
; *   This is the trap routine, which will be assembled then        *
; *   attached to trap.asm as a code resource, id 1000.             *
; *                                                                 *
; *   Remember that once installed, this code will execute          *
; *   independant from logohack.prc.  So it must open logohack.prc  *
; *   as a resource database in order to use any of it's resources  *
; *   (eg the logo bitmap), and it has no global data area.         *
; *                                                                 *
; *   LogoCreatorID   equ   $4c6f676f  ; 'Logo' = $4c6f676f         * 
; *   ApType          equ   $4841434b  ; 'HACK' = $4841434b         *
; *                                                                 *
; *                                                                 *
; *   Andrew Howlett                                                *
; *   howlett@iosphere.net                                          *
; *   1 Mar 97                                                      *
; *                                                                 *
; *******************************************************************

    include "Pilot.inc"
    include "logo.inc"

    data
global  lFoo.l      ; pila requires one global

    code

;proc    MySysHandleEventTrap(pevt.l)
proc    MyHwrLCDWakeTrap()
local   pfnOldProc.l
beginproc

    ; get original trap address and do it
    ; (we have to wake up the LCD first, or you won't see the logo)
    
    systrap FtrGet(#LogoCreatorID.l, #TrapCodeID.w, &pfnOldProc(a6).l)
    move.l  pfnOldProc(a6),a0
    jsr (a0)

    movem.l d2/a3-a4,-(a7)              ; save dirty registers

    ; The logo bitmap is embedded in the LogoForm,
    ; so show the logo form.
    ; We have to open logohack.prc as a resource database
    ; to show its form resource.

    systrap DmOpenDatabaseByTypeCreator (#ApType.l, #LogoCreatorID.l, #dmModeReadOnly.w)
    move.l  a0, a4
    systrap FrmInitForm(#LogoFormID.w)
    move.l  a0, a3                                   ; save a copy of FormPtr for later
    systrap FrmDrawForm(a3.l)

;   Delay for 2 seconds.  Unfortunately, SysTaskDelay locks up.
;   So there are two options:  hard code a loop, or use HwrDelay. 

;   systrap SysTaskDelay(#200.l)

;    move.l  #540000, d2
;    clr.l   d0
;TimeLoop
;    add.l   #1, d0
;    cmp.l   d0, d2
;    bgt     TimeLoop

    systrap HwrDelay (#1200000.l)

    ; erase the form, close logohack.prc, and restore the dirty registers
    
    systrap FrmEraseForm(a3.l)
    systrap FrmDeleteForm(a3.l)
    systrap DmCloseDatabase(a4.l)
    movem.l  (a7)+,d2/a3-a4

endproc

    end
